# Class AbstractPublishToMaven

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.publish.maven.tasks.AbstractPublishToMaven

All Implemented Interfaces:
  `Comparable<Task>, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.TaskInternal, Named, ExtensionAware, Task, Configurable<Task>`

Direct Known Subclasses:
  `PublishToMavenLocal, PublishToMavenRepository`

@DisableCachingByDefault(because="Abstract super-class, not to be instantiated directly") public abstract class AbstractPublishToMaven extends DefaultTask
Base class for tasks that publish a `MavenPublication`.

Since:
  2.4

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from interface Named

  `Named.Namer`

- ## Field Summary

  ### Fields inherited from interface Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractPublishToMaven()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract org.gradle.api.publish.maven.internal.publisher.MavenDuplicatePublicationTracker`
  `getDuplicatePublicationTracker()`
  `protected abstract org.gradle.api.publish.maven.internal.publisher.MavenPublishers`
  `getMavenPublishers()`
  `MavenPublication`
  `getPublication()`
  The publication to be published.
  `protected org.gradle.api.publish.maven.internal.publication.MavenPublicationInternal`
  `getPublicationInternal()`
  `void`
  `setPublication(MavenPublication publication)`
  Sets the publication to be published.

  ### Methods inherited from class DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, doNotTrackStateIf, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getLoggingManager, getOnlyIf, getReasonNotToTrackState, getReasonsNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, restoreOnlyIf, restoreTaskActions, setImpliesSubProjects`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface Task

  `doNotTrackState, notCompatibleWithConfigurationCache`

- ## Constructor Details

  - ### AbstractPublishToMaven

    public AbstractPublishToMaven()

- ## Method Details

  - ### getPublication

    @Internal public MavenPublication getPublication()
    The publication to be published.
    Returns:
      The publication to be published

  - ### setPublication

    public void setPublication(MavenPublication publication)
    Sets the publication to be published.
    Parameters:
      `publication` - The publication to be published

  - ### getPublicationInternal

    @Internal protected org.gradle.api.publish.maven.internal.publication.MavenPublicationInternal getPublicationInternal()

  - ### getMavenPublishers

    @Inject protected abstract org.gradle.api.publish.maven.internal.publisher.MavenPublishers getMavenPublishers()

  - ### getDuplicatePublicationTracker

    @Inject protected abstract org.gradle.api.publish.maven.internal.publisher.MavenDuplicatePublicationTracker getDuplicatePublicationTracker()